#include<iostream>
using namespace std;
int main()
{
    long long N;
    cin>>N;
    long long mesta[N],im, iz=0, zabraneniIm[N];
    for(im=0; im<N; im++)
    {
        cin>>mesta[im];
        if(im>0 && im<N)
        {
            if(mesta[im-2]>mesta[im-1]&&mesta[im]>mesta[im-1])
            {
                zabraneniIm[iz]=im-1;
                iz++;
            }
            else
            {
                if(mesta[im-2]<mesta[im-1]&&mesta[im]<mesta[im-1])
                {
                    zabraneniIm[iz]=im-1;
                    iz++;
                }
            }
        }
    }
    //cout<<iz<<" ";
    long long stypki=0, var=0, i;
    for(im=0; im<=iz; im=zabraneniIm[im+1])
    {
        //cout<<im<<" ";
        if(im==0)
        {
            stypki=zabraneniIm[im]-im;
            for(i=1; i<=stypki; i++)
            {
                var+=i;
            }
            //cout<<" 1 "<<var;
        }
        else
        {
            if(im==iz)
            {

                stypki=zabraneniIm[im]-N-1;
                for(i=1; i<=stypki; i++)
                {
                    var+=i;
                }
                //cout<<" 2 "<<var;
            }
            else
            {

                stypki=zabraneniIm[im+1]-zabraneniIm[im];
                for(i=1; i<=stypki; i++)
                {
                    var+=i;
                }
                //cout<<" 3 "<<var;
            }
        }
    }
    if(zabraneniIm[im+1]>iz)
    {
        stypki=zabraneniIm[im]-N-1;
        for(i=1; i<=stypki; i++)
        {
            var+=i;
        }
        //cout<<" 2 "<<var;
    }
    //cout<<zabraneniIm[im+1]<<" ";

    cout<<var*2<<endl;
    return 0;
}
